public class Knoten extends Baumelement
{
    private int daten;
    private Baumelement links;
    private Baumelement rechts;
    
    public Knoten() {
        links=new Abschluss();
        rechts=new Abschluss();
    }
    
    public Knoten(int datenNeu) {
        daten=datenNeu;
        links=new Abschluss();
        rechts=new Abschluss();
    }
    
    public void preOrder() {
        System.out.println(daten);
        links.preOrder();
        rechts.preOrder();
    }
    public void inOrder() {
        links.inOrder();
        System.out.println(daten);
        rechts.inOrder();
    }
    public void postOrder() {
        links.postOrder();
        rechts.postOrder();
        System.out.println(daten);
    }
    public Baumelement insert(int datenNeu) {
        if (datenNeu<daten) {
            links=links.insert(datenNeu);
        } else {
            if (datenNeu!=daten) {
                //auch gleiche
                rechts=rechts.insert(datenNeu);
            }
        }
        return this;
    }
    public void datenAusgeben() {
    }
    
    public StringBuilder toString(StringBuilder prefix, boolean isTail, StringBuilder sb) {
        /*if(!(rechts instanceof Abschluss)) {
            rechts.toString(new StringBuilder().append(prefix).append(isTail ? "?   " : "    "), false, sb);
        }*/
        rechts.toString(new StringBuilder().append(prefix).append(isTail ? "|   " : "    "), false, sb);
        sb.append(prefix).append(isTail ? " \\- " : "/- ").append(daten).append("\r\n");
        links.toString(new StringBuilder().append(prefix).append(isTail ? "    " : "|   "), true, sb);
        /*if(!(links instanceof Abschluss)) {
            links.toString(new StringBuilder().append(prefix).append(isTail ? "    " : "?   "), true, sb);
        }*/
        return sb;
    }
}
